%% Microscopy Image Browser License
%
% *Back to* <im_browser_product_page.html *Index*>
%%
% 
% <html>
% Developed during 2010-2017 by<br>
% Core developer:<br>
% <a href="http://www.biocenter.helsinki.fi/~ibelev/">Ilya Belevich</a><br>
% Developers:<br>
% Merja Joensuu, Darshan Kumar, Helena Vihinen and Eija Jokitalo<br><br>
% <i><a href="http:\\www.biocenter.helsinki.fi/bi/em">Electron Microscopy Unit</a><br>
% Institute of Biotechnology<br>
% PO Box 56 (Viikinkaari 9)<br>
% 00014, University of Helsinki<br>
% Finland</i>
% </html>
%
%
%% GPL license of Microscopy Image Browser
%
% <html>
% Microscopy Image Browser (MIB) a handy tool for image management<br>
% Copyright (c) 2010-2017<br>
% Ilya Belevich, Merja Joensuu, Darshan Kumar, Helena Vihinen and Eija Jokitalo<br>
% http://mib.helsinki.fi<br>
% </html>
% 
%
% This program is free software; you can redistribute it and/or modify it under the terms of the <
% http://www.gnu.org/licenses/gpl-2.0.html GNU General Public License> as published by the Free Software 
% Foundation; either version 2 of the License, or (at your option) any later version. 
% 
% This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; 
% without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
%
% <http://www.gnu.org/licenses/gpl-2.0.html See the GNU General Public License for more details> . 
% 
% You should have received a copy of the GNU General Public License along with this program; 
% if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. 
%
%% EXTERNAL PACKAGES
% 
% Microscopy Image Browser as a bundle is licensed under the GPL, with exceptions for plugins and other components.  
% This section lists the license under which additional components are released. See also the <im_browser_ack.html Acknowledgements> section
%
% Abbreviations:
% * <https://en.wikipedia.org/wiki/BSD_licenses#2-clause_license_.28.22Simplified_BSD_License.22_or_.22FreeBSD_License.22.29 *FreeBSD*>, Berkeley Software Distribution, 2-clause license, GPL compatible
% * <http://www.gnu.org/licenses/gpl-2.0.html *GPL*>, GNU General Public License, version 2
% * <https://en.wikipedia.org/wiki/BSD_licenses#3-clause_license_.28.22Revised_BSD_License.22.2C_.22New_BSD_License.22.2C_or_.22Modified_BSD_License.22.29 *ModifiedBSD*>, Berkeley Software Distribution, 3-clause license, GPL compatible 
% * <http://en.wikipedia.org/wiki/MIT_License *MIT*>, a free software license originating at the Massachusetts Institute of Technology, GPL compatible
% * *ND*, no data
%%
% 
% <html>
% <table style="width: 800px; text-align: center;" cellspacing=2px cellpadding=2px >
% <tr style="font-weight: bold; background: #ff6600;">
%   <td>Name</td>
%   <td>Author(s)</td>
%   <td>Contact</td>
%   <td>License, Year</td>
%   <td>MIB<br>version</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Accurate Fast Marching</td>
%   <td>Dirk-Jan Kroon, University of Twente</td>
%   <td><a href="http://www.mathworks.se/matlabcentral/fileexchange/24531-accurate-fast-marching">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2011</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">ANISODIFF</td>
%   <td>Peter Kovesi</td>
%   <td><a href="http://www.peterkovesi.com/matlabfns/#anisodiff">web site</a></td>
%   <td>MIT,<br> 2000-2002</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Bio-Formats</td>
%   <td>Melissa Linkert, Curtis Rueden et al.</td>
%   <td><a href="http://loci.wisc.edu/software/bio-formats">web site</a></td>
%   <td>GPL,<br> 2002-2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">bwdistsc, 3D Euclidean distance transform for variable data aspect ratio</td>
%   <td>Yuriy Mishchenko, Toros University</td>
%   <td><a href="http://www.mathworks.se/matlabcentral/fileexchange/15455-3d-euclidean-distance-transform-for-variable-data-aspect-ratio">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2007-2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">DrawRegionBoundaries</td>
%   <td>Peter Kovesi<br>
%   Centre for Exploration Targeting, School of Earth and Environment, The
%   University of Western Australia</td>
%   <td><a href="http://www.peterkovesi.com/projects/segmentation/">author's website</a></td>
%   <td>MIT,<br> 2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">drifty_shifty_deluxe</td>
%   <td>Joshua D. Sugar<br>
%   Sandia National Laboratories, Livermore, CA</td>
%   <td><a href="https://se.mathworks.com/matlabcentral/fileexchange/45453-drifty-shifty-deluxe-m">via Matlab Exchange</a></td>
%   <td><a href="https://se.mathworks.com/matlabcentral/fileexchange/view_license?file_info_id=45453">Custom</a>,<br> 2014</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Export_fig</td>
%   <td>Oliver Woodford and Yair Altman</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/23629-export-fig">via Matlab Exchange</a></td>
%   <td>ModifiedBSD,<br>2014-2015</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Extrema functions</td>
%   <td>Carlos Adrian Vargas Aguilera, Universidad de Guadalajara</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/12275-extrema-m-extrema2-m">via Matlab Exchange</a></td>
%   <td>ND,<br> 2006-2007</td>
%   <td>0.x-1.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Fast 3D/2D Region Growing (MEX)</td>
%   <td>Christian Wuerslin, Stanford University</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/41666-fast-3d-2d-region-growing--mex-">via Matlab Exchange</a></td>
%   <td>ModifiedBSD,<br> 2013-2015</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Fast/Robust Template Matching
%              <div style="font-weight: normal;">used in MIB 1.22 and earlier</div>
%   </td>
%   <td>Dirk-Jan Kroon, University of Twente</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/24925-fastrobust-template-matching">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2009-2011</td>
%   <td>0.x-1.22</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">FindJObj - find java handles of Matlab graphic objects</td>
%   <td>Yair Altman</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/14317-findjobj-find-java-handles-of-matlab-graphic-objects">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2007-2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Hardware accelerated 3D viewer for MATLAB</td>
%   <td>Jean-Yves Tinevez, Institut Pasteur</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/32344-hardware-accelerated-3d-viewer-for-matlab">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2011</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Hessian based Frangi Vesselness filter</td>
%   <td>Marc Schrijver and Dirk-Jan Kroon, University of Twente</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/24409-hessian-based-frangi-vesselness-filter">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2001-2009</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Highly portable JSON-input parser</td>
%   <td>Nedialko</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/25713-highly-portable-json-input-parser">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br>2009</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">IceImarisConnector</td>
%   <td>Aaron C. Ponti, ETH Zurich</td>
%   <td><a href="http://www.scs2.net/next/index.php?id=110">web link</a></td>
%   <td>GPL,<br> 2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Image Edge Enhancing Coherence Filter</td>
%   <td>Dirk-Jan Kroon, Pascal Getreuer University of Twente</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/25449-image-edge-enhancing-coherence-filter-toolbox">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2009</td>
%   <td>0.x-1.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Image Measurement Utility</td>
%   <td>Jan Neggers, Eindhoven Univeristy of Technology</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/25964-image-measurement-utility">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2009-2014</td>
%   <td>1.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">ImageViewer</td>
%   <td>Jiro Doke, Mathworks</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/13000-imageviewer">via Matlab Exchange</a></td>
%   <td>ModifiedBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">ImClipboard</td>
%   <td>Jiro Doke, MathWorks</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/28708-imclipboard">via Matlab Exchange</a></td>
%   <td>ModifiedBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">ImGaussian</td>
%   <td>Dirk-Jan Kroon, University of Twente</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/25397-imgaussian">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2009</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Local Normalization</td>
%   <td>Guanglei Xiong at Tsinghua University, Beijing</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/8303-local-normalization">via Matlab Exchange</a></td>
%   <td>ND,<br> 2005</td>
%   <td>0.x-1.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">MatTomo, a part of PEET</td>
%   <td>Boulder Laboratory for 3-D Electron Microscopy of Cells</td>
%   <td><a href="http://bio3d.colorado.edu/PEET/index.html">web site</a></td>
%   <td>GPL,<br> 2006-2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">MAXFLOW/MINCUT algorithm v2.22</td>
%   <td>Yuri Boykov, University of Western Ontario and Vladimir Kolmogorov, Microsoft research, Cambridge</td>
%   <td><a href="http://pub.ist.ac.at/~vnk/software.html">web site</a></td>
%   <td>GPL,<br> 2001-2014</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">MAXFLOW/MINCUT Matlab wrapper</td>
%   <td>Michael Rubinstein, Google</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/21310-maxflow">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2008</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Membrane detection with Random Forest</td>
%   <td>Verena Kaynig, Harvard School of Engineering and Applied Sciences</td>
%   <td><a href="http://www.kaynig.de/demos.html">web link</a></td>
%   <td>GPL,<br>2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">MTOC++</td>
%   <td>Martin Drohmann (Universitt Mnster), Daniel Wirtz (Universitt Stuttgart)</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/33826-mtoc++-doxygen-filter-for-matlab-and-tools">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2011-2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">NRRD Format File Reader</td>
%   <td>Jeff Mather, the MathWorks, Inc.</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/34653-nrrd-format-file-reader">via Matlab Exchange</a></td>
%   <td>ModifiedBSD,<br>2012</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Projects:MATLABSlicerExampleModule, to read NRRD format</td>
%   <td>John Melonakos</td>
%   <td><a href="http://www.na-mic.org/Wiki/index.php/Projects:MATLABSlicerExampleModule">web link</a></td>
%   <td>GPL,<br>2012</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Random Forest Matlab</td>
%   <td>Abhishek Jaiantilal</td>
%   <td><a href="https://code.google.com/p/randomforest-matlab/">web link</a></td>
%   <td>GPL,<br> 2012</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Region Adjacency Graph (RAG)</td>
%   <td>David Legland, INRA, France</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/16938-region-adjacency-graph--rag-">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2007-2013</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">RegionProps3</td>
%   <td>Chaoyuan Yeh</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/authors/393471">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2014</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Render</td>
%   <td>Dirk-Jan Kroon, Focal Machine Vision en Optical Systems</td>
%   <td><a href="http://se.mathworks.com/matlabcentral/fileexchange/21993-viewer3d">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2008-2011</td>
%   <td>1.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">Render RGB text over RGB or Grayscale Image</td>
%   <td>Davide Di Gloria, Universita di Genova</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/26940-render-rgb-text-over-rgb-or-grayscale-image">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">SLIC (Simple Linear Iterative Clustering)</td>
%   <td>Radhakrishna Achanta, Appu Shaji, Kevin Smith, Aurelien Lucchi, 
% Pascal Fua, and Sabine Ssstrunk<br>Ecole Polytechnique Federale de
% Lausanne (EPFL), Switzerland</td>
%   <td><a href="http://ivrl.epfl.ch/supplementary_material/RK_SLICSuperpixels/index.html">authors' website</a></td>
%   <td>ModifiedBSD,<br> 2015</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">STLWRITE</td>
%   <td>Sven Holcombe, University of Michigan</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/20922-stlwrite-filename--varargin-">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2008-2015</td>
%   <td>1.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">STRUCT2XML</td>
%   <td>Wouter Falkena, Delft University of Technology</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/28639-struct2xml">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">VIEW3D</td>
%   <td>Torsten Vogel</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/334-view3d-m">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 1999</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">XLSWRITE (improved)</td>
%   <td>Barry Dillon, AON Insurance Brokers</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/27236-improved-xlswrite-m">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% <tr style="">
%   <td style="font-weight: bold">XML2STRUCT</td>
%   <td>Wouter Falkena, Delft University of Technology</td>
%   <td><a href="http://www.mathworks.com/matlabcentral/fileexchange/28518-xml2struct">via Matlab Exchange</a></td>
%   <td>FreeBSD,<br> 2010</td>
%   <td>0.x-2.x</td>
% </tr>
% </table>
% </html>
%
%% HOW TO CITE
%
%%
% <html>
% In November 2015 paper describing Microscopy Image Browser was accepted for publication in PLOS Biology, 
% please cite it whenever referring to the software (the reference will be updated as soon as the article is published):
% <br><br>
% <b>
% Microscopy Image Browser: A platform for segmentation and analysis of
% multidimensional datasets<br>
% I. Belevich, M. Joensuu, D. Kumar, H. Vihinen and E. Jokitalo<br>
% PLOS Biology, PLoS Biology 2016 Jan 4;14(1):e1002340. doi: 10.1371/journal.pbio.1002340<br>
% <http://journals.plos.org/plosbiology/article?id=10.1371/journal.pbio.1002340 Link to the article>
% <br></b>
% We appreciate if you let us know by email (ilya.belevich -=@=- helsinki.fi) when you cite MIB. This helps us to develop and maintain the program.
% </html>
%
% *Back to* <im_browser_product_page.html *Index*>